# queue.h File Reference

## Detailed Description

Lock-free double-ended queue. This file is a GNU parallel extension to the Standard C++ Library.

Definition in file queue.h.

Go to the source code of this file.

## Namespaces

- namespace __gnu_parallel

## Classes

- class __gnu_parallel::RestrictedBoundedConcurrentQueue< T >
    Double-ended queue of bounded size, allowing lock-free atomic access. push_front() and pop_front() must not be called concurrently to each other, while pop_back() can be called concurrently at all times. `empty()`, `size()`, and `top()` are intentionally not provided. Calling them would not make sense in a concurrent setting. More...

## Defines

- #define _GLIBCXX_PARALLEL_QUEUE_H
- #define _GLIBCXX_VOLATILE

## Define Documentation

#define _GLIBCXX_VOLATILE

Decide whether to declare certain variable volatile in this file.

Definition at line 46 of file queue.h.